﻿using System;
using System.Collections.Generic;

namespace producerConsumer
{
    /// <summary>
    /// Abstract class implementing the common parts of BoundedBuffer and UnboundedBuffer
    /// </summary>
    public abstract class AbstractBuffer : IBuffer
    {
        protected readonly Queue<int> Queue = new Queue<int>();

        public abstract void Add(int element);

        public abstract int Take();

        public int Count
        {
            get { return Queue.Count; }
        }

        public Boolean IsEmpty()
        {
            return (Queue.Count == 0);
        }
    }
}
