﻿using System.Collections.Generic;

namespace producerConsumer
{
    public class Copier
    {
        private readonly IBuffer _ingoingBuffer;
        private readonly IEnumerable<IBuffer> _outgoingBuffers;

        public Copier(IBuffer ingoingBuffer, IEnumerable<IBuffer> outgoingBuffers)
        {
            _ingoingBuffer = ingoingBuffer;
            _outgoingBuffers = outgoingBuffers;
        }

        public void Run()
        {
            while (true)
            {
                int element = _ingoingBuffer.Take();
                foreach (IBuffer outgoingBuffer in _outgoingBuffers)
                {
                    outgoingBuffer.Add(element);
                }
                if (element == Producer.LastElement)
                {
                    break;
                }
            }
        }

    }
}
