﻿using System;

namespace producerConsumer
{
    /// <summary>
    /// MiddleMan is a worker that takes from one buffer and adds into another buffer-
    /// </summary>
    public class MiddleMan
    {
        private readonly IBuffer _fromBuffer;
        private readonly IBuffer _toBuffer;

        /// <summary>
        /// Constructs a new object of this class.
        /// </summary>
        /// <param name="fromBuffer">the buffer to take from</param>
        /// <param name="toBuffer">the buffer to added to</param>
        public MiddleMan(IBuffer fromBuffer, IBuffer toBuffer)
        {
            _fromBuffer = fromBuffer;
            _toBuffer = toBuffer;
        }

        /// <summary>
        /// Runs this object.<br />
        /// Stops when it takes Producer.LastItem
        /// </summary>
        public void Run()
        {
            while (true)
            {
                int element = _fromBuffer.Take();
                _toBuffer.Add(element);
                Console.WriteLine("Middleman handled: {0}", element);
                if (element == Producer.LastElement)
                {
                    break;
                }
            }
        }

    }
}
